#include "Common.h"
#include "A1.h"

///////////////////////////////////////////////////////////////
//   A1

void A1_Step(int e)
{
    switch (A1_y)
    {
        case 0: //  
            if (e==A1_e0) {
                // WriteLog("   0  e0",0);
                A1_z1_0();
			} else
            if (e==A1_e2) {
                // WriteLog("   0  e2",0);
                A1_z3_0();
			} else
			if (A0_y==3&&!A1_x3_0()) {
				A1_z1_1();
				A1_y=1;
			} else
			if (A0_y==3&&A1_x3_0()) {
				A1_z2_1();
				A1_y=2;
			} else
			if (A0_y==4&&!A1_x3_0()) {
				A1_z1_2();
				A1_y=3;
			} else
			if (A0_y==4&&A1_x3_0()) {
				A1_z2_2();
				A1_y=4;
			}
        break;
        case 1: //    
			if (!A1_x1_1()) {
				A1_z1_1();
			} else
			if (A1_x1_1()) {
				A1_z2_1();
				A1_y=2;
			}
		break;
        case 2: //  
			if (!A1_x2_1()) {
				A1_z2_1();
			} else
			if (A1_x2_1()) {
				A1_y=0;
			}
		break;
        case 3: //    
			if (!A1_x1_2()) {
				A1_z1_2();
			} else
			if (A1_x1_2()) {
				A1_z2_2();
				A1_y=4;
			}
		break;
        case 4: //  
			if (!A1_x2_2()) {
				A1_z2_2();
			} else
			if (A1_x2_2()) {
				A1_y=0;
			}
		break;
    }
}

///////////////////////////////////////////////////////////////
//  

// ,     

int A1_x1_1()
{	         
	return (rope==5.0-floor-1.0/(TUP+1));
}

int A1_x1_2()
{
	return (rope==3.0-floor+1.0/(TDOWN+1));
}

int A1_x2_1()
{
	return (rope==4.0-floor);
}

int A1_x2_2()
{
	return (rope==4.0-floor);
}

// ,    

int A1_x3_0()
{
	return (accelerated==true);
}

///////////////////////////////////////////////////////////////
//  

//     

void A1_z1_0()
{
    // WriteLog(" z1_0",1);
    rope=2.0;
}

void A1_z1_1()
{
    // WriteLog(" z1_1",1);
	rope-=1.0/((TUP+1)*TSTARTING);
	if ((int)(rope+1)-rope>1.0/(TUP+1)) rope=5.0-floor-1.0/(TUP+1);
}

void A1_z1_2()
{
    // WriteLog(" z1_2",1);
	rope+=1.0/((TDOWN+1)*TSTARTING);
	if (rope-(int)(rope)>1.0/(TDOWN+1)) rope=3.0-floor+1.0/(TDOWN+1);
}

void A1_z2_1()
{
    // WriteLog(" z2_1",1);
	accelerated=true;
	rope-=1.0/(TUP+1);
	if (4.0-floor>rope) rope=4.0-floor;
}

void A1_z2_2()
{
    // WriteLog(" z2_1",1);
	accelerated=true;
	rope+=1.0/(TDOWN+1);
	if (4.0-floor<rope) rope=4.0-floor;
}

//    

void A1_z3_0()
{
    // WriteLog(" z3_0",1);
	accelerated=false;
}
